#include "SerialComm.h"

CSerialComm::CSerialComm()
{

}

CSerialComm::~CSerialComm()
{

}

void CSerialComm::Initialize(char *ComPort,unsigned int Baud,unsigned int Nbytes,unsigned int Parity,unsigned int StopBit)
{
	strcpy(this->ComPort,ComPort);
	CommHandle = CreateFile(ComPort, GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
	PortReady = SetupComm(CommHandle , 128, 128);
	
	PortReady = GetCommState(CommHandle, &dcb);
	
	dcb.BaudRate = Baud;
	dcb.ByteSize = Nbytes;
	dcb.Parity = Parity;
	dcb.StopBits = StopBit;
	dcb.fAbortOnError = TRUE;
	
	PortReady = SetCommState(CommHandle , &dcb);

	PortReady = GetCommTimeouts (CommHandle, &CommTimeouts);

	CommTimeouts.ReadIntervalTimeout =	MAXDWORD;
	CommTimeouts.ReadTotalTimeoutConstant = MAXDWORD;
	CommTimeouts.ReadTotalTimeoutMultiplier = MAXDWORD;
	CommTimeouts.WriteTotalTimeoutConstant = 50;
	CommTimeouts.WriteTotalTimeoutMultiplier = 10;

	PortReady = SetCommTimeouts (CommHandle, &CommTimeouts);
}

BOOL CSerialComm::ReadByte(char *c,float TimeOut)
{
	BOOL bReadRC;
	float time=TimeOut;
	unsigned long BytesRead=0;

	while ((BytesRead==0)&&(time>0))
	{
		time--;
		bReadRC = ReadFile(CommHandle, c, 1, &BytesRead, NULL);
	}

	if (time==0) return FALSE;
	else return TRUE;

}

BOOL CSerialComm::WriteByte (char c,float TimeOut)
{
	float time=TimeOut;
	BOOL bWriteRC;
	unsigned long BytesWritten=0;

	while ((BytesWritten==0)&&(time>0))
	{
		time--;
		bWriteRC = WriteFile(CommHandle,&c,1,&BytesWritten,NULL);
	}

	if (time==0) return FALSE;
	else return TRUE;
}

BOOL CSerialComm::ReadShort(short *c,float TimeOut)
{
	BOOL result;
	char temp[2];

	result=ReadByte(temp,TimeOut);
	if (!result) return FALSE;
	result=ReadByte(&temp[1],TimeOut);
	if (!result) return FALSE;
	
	(*c)=*((short *) temp);
	return TRUE;
}

BOOL CSerialComm::WriteShort (short c,float TimeOut)
{
	BOOL result;
	result=WriteByte(*((char *) &c),TimeOut);
	if (!result) return FALSE;
	result=WriteByte(*(((char *) &c)+1),TimeOut);
	if (!result) return FALSE;

	return TRUE;
}